#ifndef SYSTEM_DIALOG_H
#define SYSTEM_DIALOG_H

#include <string>

class PDialog {
public:
	virtual bool open(const std::string &ext, std::string &result) = 0;
	virtual bool save(const std::string &ext, std::string &result) = 0;
};

class IDialog : public PDialog {
	PDialog *imp;
public:
	IDialog();
	void setImp(PDialog *imp_);
	virtual bool open(const std::string &ext, std::string &result);
	virtual bool save(const std::string &ext, std::string &result);
};

#endif	//SYSTEM_DIALOG_H
