//something for the apple launchers
#ifdef __APPLE__

#include <string.h>
#include <assert.h>
#include <unistd.h>
#include <sys/param.h>
#include "defs/defs.h"

bool osxAdjustArguments(int &argc, char ** &argv) {
	//hack.
	//set the cwd. 
	
	//TODO - just clip these off argc/argv for __APPLE__
	//(via reconstruction or ptr offset?)
	//and don't have a separate #ifdef in base

	//when you run it from xcode it fills in some gimp path (you can pick it from xcode)
	//but when you run it from finder it gives you / as the path
	//completely misleading
	bool hackdir = false;
	for (int i = 0; !hackdir && i < argc; i++) {
		hackdir |= strlen(argv[i]) > 4 && !memcmp(argv[i], "-psn", 4);
	}
	
	char *altArgv[256];
	int altArgc = 0;
	
	if (hackdir) {
		{
			char parentdir[MAXPATHLEN];
			char *c;
			strncpy ( parentdir, argv[0], sizeof(parentdir) );
			c = parentdir;
			while (*c != '\0') c++;	//end of parent dir
			while (*c != '/') c--;	//find the dir name - cut off the binary's name
			*c++ = '\0';
			int res;
			res = chdir(parentdir); assert(!res);   // chdir to the binary app's parent
			res = chdir("../../../"); assert(!res); // chdir to the .app's parent
		}
		
		for (int i = 0; i < argc; i++) {
			if (!(strlen(argv[i]) > 4 && !memcmp(argv[i], "-psn", 4))) {
				assert(altArgc < numberof(altArgv));
				altArgv[altArgc] = argv[i];
				altArgc++;
			}
		}
		argv = altArgv;
		argc = altArgc;
	}
	
#if 0		
	//now if we're in xcode then this hack applies too
	//move back beyond the "build/Debug/" folders
	//maybe I should just have the .app copied to the root dir before execution
	//maybe I should package all the data in the .app ...
	if (!hackdir) {
		res = chdir("../.."); assert(!res);
	}
#endif

	return hackdir;
}

#endif	//__APPLE__