#include <assert.h>

#include "system/exception.h"
#include "system/timer.h"

IHiResTimer::IHiResTimer() : imp(NULL) {}
void IHiResTimer::setImp(PHiResTimer *_imp) { imp = _imp; }
void IHiResTimer::init() {
	assert(imp);
	imp->init();
}
double IHiResTimer::getTime() {
	assert(imp);
	return imp->getTime();
}
